#include<bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;
const int N=2e5+5;
#define F first
#define S second
int id,n,q,l,r; ull ans;
int a[N],b[N];
namespace S1{
	ull tr[2][N];
	pair<int,int> p1[N],p2[N];
	void update(int k, int x, ull y){
		for (; x<=n; x+=x&-x) tr[k][x]+=y;
	}
	void clr(int x){
		for (; x<=n; x+=x&-x) tr[0][x]=tr[1][x]=0;
	}
	ull query(int k, int l, int r){
		if (l>r) return 0;
		ull x=0; l--;
		for (; r; r-=r&-r) x+=tr[k][r];
		for (; l; l-=l&-l) x-=tr[k][l];
		return x;
	}
	void solve(int l, int r){
		if (l==r) return ans+=1ull*a[l]*b[r],void();
		int mid=(l+r)>>1,m1=0,m2=0,l1=0,l2=0;
		for (int i=mid; i>=l; i--){
			m1=max(m1,a[i]); m2=max(m2,b[i]);
			p1[++l1]={m1,m2};
		}
		m1=m2=0;
		for (int i=mid+1; i<=r; i++){
			m1=max(m1,a[i]); m2=max(m2,b[i]);
			p2[++l2]={m1,m2};
		}
		sort(p1+1,p1+1+l1);
		sort(p2+1,p2+1+l2); int pos=0;
		for (int i=1; i<=l1; i++){
			while (pos+1<=l2 && p2[pos+1].F<=p1[i].F){
				pos++;
				update(0,p2[pos].S,1);
				update(1,p2[pos].S,p2[pos].S);
			}
			ans+=1ull*p1[i].F*(query(0,1,p1[i].S)*p1[i].S+query(1,p1[i].S+1,n));
		}
		for (int i=1; i<=l2; i++) clr(p2[i].S);
		pos=l2+1;
		for (int i=l1; i>=1; i--){
			while (pos-1>=1 && p2[pos-1].F>p1[i].F){
				pos--;
				update(0,p2[pos].S,1ull*p2[pos].F);
				update(1,p2[pos].S,1ull*p2[pos].F*p2[pos].S);
			}
			ans+=query(0,1,p1[i].S)*p1[i].S+query(1,p1[i].S+1,n);
		}
		for (int i=1; i<=l2; i++) clr(p2[i].S);
		solve(l,mid);
		solve(mid+1,r);
	}
	void solve(){
		for (; q; q--){
			scanf("%d%d",&l,&r); ans=0;
			solve(l,r);
			printf("%llu\n",ans);
		}
	}
}
namespace S2{
	ull val[3005][3005];
	void solve(){
		for (int i=1; i<=n; i++){
			int p1=0,p2=0;
			for (int j=i; j<=n; j++){
				p1=max(p1,a[j]),p2=max(p2,b[j]);
				val[i][j]=1ull*p1*p2;
			}
		}
		for (int i=n; i>=1; i--)
			for (int j=i; j<=n; j++) val[i][j]+=val[i][j-1]+val[i+1][j]-val[i+1][j-1];
		for (; q; q--){
			scanf("%d%d",&l,&r);
			printf("%llu\n",val[l][r]);
		}
	}
}
int main(){
	freopen("match.in","r",stdin);
	freopen("match.out","w",stdout);
	scanf("%d%d",&id,&n);
	for (int i=1; i<=n; i++) scanf("%d",&a[i]);
	for (int i=1; i<=n; i++) scanf("%d",&b[i]);
	scanf("%d",&q);
	if (6<=id && id<=13) S1::solve();
	else S2::solve();
	return 0;
}
/*
6 30
9 30 25 18 7 3 29 15 12 16 14 26 24 5 1 8 13 28 6 17 2 22 4 23 27 10 11 19 20 21
27 24 11 26 7 3 8 15 25 10 1 4 18 14 20 23 9 22 29 30 13 28 19 17 2 21 6 12 5 16
30
1 30
1 30
6 30
3 26
4 26
6 28
1 24
4 30
7 29
3 24
7 30
3 26
4 26
2 29
4 30
6 21
8 29
11 14
15 19
19 20
7 30
25 30
7 9
19 30
7 26
13 26
5 30
15 24
18 21
23 29
*/