#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 1005;
const ll P = 998244353;

int n, m, _C, _F;
char a[N][N];
int R[N][N], D[N][N];

void task()
{
	scanf("%d%d%d%d", &n, &m, &_C, &_F);
	for (int i = 1; i <= n; i++)
		scanf(" %s", a[i] + 1);
	for (int i = 0; i <= n + 1; i++)
		for (int j = 0; j <= m + 1; j++)
			R[i][j] = D[i][j] = 0;
	for (int i = 1; i <= n; i++)
	{
		R[i][m] = m;
		for (int j = m - 1; j >= 1; j--)
			R[i][j] = (a[i][j + 1] == '0' ? R[i][j + 1] : j);
	}
	for (int j = 1; j <= m; j++)
	{
		D[n][j] = n;
		for (int i = n - 1; i >= 1; i--)
			D[i][j] = (a[i + 1][j] == '0' ? D[i + 1][j] : i);
	}
	ll ansc = 0, ansf = 0;
	for (int j = 1; j <= m; j++)
	{
		ll sum = 0;
		ll lst = 0;
		for (int i = 1; i <= n; i++)
		{
			ll cur = 0;
			if (a[i][j] == '0')
			{
				if (R[i][j] > j) 
				{
					cur = R[i][j] - j;
					ansc = (ansc + cur * sum) % P;
					if (D[i][j] > i)
					{
						ansf = (ansf + cur * sum % P * (D[i][j] - i)) % P;
					}
				}
				sum = (sum + lst) % P;
				lst = cur;
			}
			else lst = sum = 0;
		}
	}
	ansc = ansc * _C % P;
	ansf = ansf * _F % P;
	printf("%lld %lld\n", ansc, ansf);
}

int main()
{
	freopen("plant.in", "r", stdin);
	freopen("plant.out", "w", stdout);
	int T, id;
	scanf("%d%d", &T, &id);
	while (T--) task();
}
/*
3 0
6 6 1 1
000010
011000
000110
010000
011000
000000
6 6 1 1
000010
011000
000110
010000
011000
000000
6 6 1 1
000010
011000
000110
010000
011000
000000
*/