#include <bits/stdc++.h>
using namespace std;

template<typename T>
ostream& operator<<(ostream& ost, const vector<T>& a) {
	bool first = true;
	for (const T& x : a) {
		if (!first) ost << ",";
		ost << x, first = false;
	}
	return ost;
}

void debug_out() { cerr << "\n"; }

template<typename U, typename... T>
void debug_out(const U& x, const T&... args) {
	cerr << " " << x;
	debug_out(args...);
}

#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__) // debuger

int cur = 0;

void dfs(int x) {
	if (!x) return;
	cur += x;
	dfs(x - 1);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	// auto dfs = [&](auto dfs, int x)->void {
	// 	if (!x) return;
	// 	cur += x;
	// 	dfs(dfs, x - 1);
	// };
	dfs(1000000);
}